#include <math.h>
#include "3d.h"

int henkan3dzahyou(double* ox,double* oy,
		double x,double y,double z,const camera_t* camera) {
	double dx,dy,dz;/*JĂ*/
	double hx,hy,hz;/*JĂւ̐*/
	double kx,ky,kz;/*̕*/
	double sx,sy,sz;/*Ɛ̕*/
	double x1,y1,z1,k;/*vZp*/
	double length;/*̒*/
	double mcos,scos,dcos;/*RTC̒l*/
	double msin;/*TC̒l*/
	double dtan;/*^WFg̒l*/
	double klength;/*p肬̎̒*/
	double dlength;/*`Ɏg*/
	/*JĂvZ*/
	dy=cos(camera->cy);
	dz=sin(camera->cy);
	dx=dy*sin(camera->cx);
	dy=dy*cos(camera->cx);
	/*vZ*/
	x1=x-camera->cx;
	y1=y-camera->cy;
	z1=z-camera->cz;
	k=(x1*dx+y1*dy+z1*dz)/(dx*dx+dy*dy+dz*dz);
	hx=x1-k*dx;
	hy=y1-k*dy;
	hz=z1-k*dz;
	length=sqrt(hx*hx+hy*hy+hz*hz);
	/*̕vZ*/
	ky=sin(camera->cx);
	kx=cos(camera->cx);
	ky=ky*cos(camera->cy);
	kz=ky*sin(camera->cy);
	/*]͖*/
	/*Ɛ̕vZ*/
	sy=sin(camera->cy);
	sz=cos(camera->cy);
	sy=sy*cos(camera->cx);
	sx=sy*sin(camera->cx);
	/*]͖*/
	/*RTC̒lvZ*/
	mcos=(hx*kx+hy*ky+hz*kz)/**/
		/(sqrt(hx*hx+hy*hy+hz*hz)*sqrt(kx*kx+ky*ky+kz*kz));/*傫̐*/
	scos=(hx*sx+hy*sy+hz*sz)/**/
		/(sqrt(hx*hx+hy*hy+hz*hz)*sqrt(sx*sx+sy*sy+sz*sz));/*傫̐*/
	dcos=(x1*dx+y1*dy+z1*dz)/**/
		/(sqrt(x1*x1+y1*y1+z1*z1)*sqrt(dx*dx+dy*dy+dz*dz));/*傫̐*/
	if(dcos<0)return 0;
	/*TC̒lvZ*/
	msin=sqrt(1-mcos*mcos)*(scos>=0?1:-1);
	/*^WFg̒lvZ*/
	dtan=sqrt(1/(dcos*dcos)-1);
	/*̒vZ*/
	klength=camera->genkai/tan(camera->genkaiangle);
	/*`ɎgvZ*/
	dlength=klength*dtan;
	/*ۂɕ`悷WvZ*/
	*ox=camera->centerx+dlength*mcos;
	*oy=camera->centery-dlength*msin;
	return 1;
}

int draw3dline(HDC hdc,double x1,double y1,double z1,
		double x2,double y2,double z2,const camera_t* camera) {
	double hx1,hy1,hx2,hy2;
	if(!henkan3dzahyou(&hx1,&hy1,x1,y1,z1,camera))return 0;
	if(!henkan3dzahyou(&hx2,&hy2,x2,y2,z2,camera))return 0;
	if(!MoveToEx(hdc,(int)hx1,(int)hy1,NULL))return 0;
	if(!LineTo(hdc,(int)hx2,(int)hy2))return 0;
	return 1;
}
